<template>
    <v-card class="ma-3" flat>
        <v-expansion-panels multiple focusable hover>
            <v-expansion-panel v-for="service in services" v-bind:key="service._id">
                <v-expansion-panel-header>
                    <v-row>
                        <v-col class="col-2">
                            <h3 class="service-title mr-5">{{ service.name }}</h3>
                        </v-col>
                        <v-col class="col-1">
                            <v-btn :color=getStatusColor(service.status,service.monitored) dark depressed>{{ getStatusText(service.status, service.monitored) }}</v-btn>
                        </v-col>
                        <v-col class="col-1">
                            <span class="service-information mx-3">{{ service.address }}</span>
                        </v-col>
                        <v-col class="col-1">
                            <span class="service-information mx-3">{{ service.port }}</span>
                        </v-col>

                        <v-spacer></v-spacer>

                        <v-col class="col-2" align="right">
                            <v-btn icon color="primary" class="mx-1" @click.stop="refreshService(service)">
                                <v-icon>fas fa-sync-alt</v-icon>
                            </v-btn>
                            <v-btn icon color="orange" class="mx-1" @click.stop="openUpdate(service)">
                                <v-icon>fas fa-edit</v-icon>
                            </v-btn>
                            <v-btn icon color="red" class="mx-1" @click.stop="openConfirm(service)">
                                <v-icon>fas fa-trash-alt</v-icon>
                            </v-btn>
                        </v-col>
                    </v-row>
                </v-expansion-panel-header>
                <v-expansion-panel-content>
                    
                </v-expansion-panel-content>

            </v-expansion-panel>
        </v-expansion-panels>
        <v-dialog v-model="deleteServiceConfirm.modal" persistent max-width="30vw">
            <ConfirmModal :currentService="selectedService" modalName="deleteServiceConfirm" :title="$t('delete-service')" :message="$t('delete-service-message')" :cancelText="$t('cancel')" :confirmText="$t('confirm')" @confirm="closeConfirmDelete" />
        </v-dialog>

        <v-dialog v-model="updateServiceModal.modal" persistent max-width="50vw">
            <CreateService :isUpdate="isAnUpdate" :currentService="selectedService" :title="$t('modify-service')" :cancelButton="$t('cancel')" :addOrUpdate="$t('modify')" @exit="closeUpdate" />
        </v-dialog>
    </v-card>
</template>

<script>
    import ConfirmModal from "@/components/services/ConfirmModal";
    import CreateService from "@/components/services/CreateService";
    import APIService from "@/api/ServicesAPI.js";

    const apiService = new APIService();

    export default {
        name: "ListServices",
        components: {
            ConfirmModal,
            CreateService,
        },
        data () {
            return {
                services: [],
                deleteServiceConfirm: {
                    modal: false,
                },
                updateServiceModal: {
                    modal: false,
                },
                selectedService: {},
                isAnUpdate: true,
            };
        },
        methods: {

            /**
             * Displays the status of a service by a color code
             * @param {String} status status of the corresponding service
             * @param {Boolean} monitored to know if the corresponding service is followed or not by the system
             */
            getStatusColor(status, monitored) {
                if (monitored === true && status === "up") {
                    return "green";
                }
                else if (monitored === true && status === "down") {
                    return "red";
                }
                else {
                    return "grey";
                }
            },

            /**
             * Displays the status of a service by text
             * @param {String} status status of the corresponding service
             * @param {Boolean} monitored to know if the corresponding service is followed or not by the system
             */
            getStatusText(status, monitored) {
                if (monitored === true && status === "up") {
                    return this.$t("up");
                }
                else if (monitored === true && status === "down") {
                    return this.$t("down");
                }
                else {
                    return this.$t("ignored");
                }
            },

            /**
             * Open modal window for update of a service
             * @param {Object} service service to update
             */
            openUpdate(service) {
                this.updateServiceModal.modal = true;
                this.selectedService = Object.assign({}, service);
                console.log("Modal window opened: update");
                console.log(this.selectedService);
            },

            /**
             * Close update modal window
             */
            closeUpdate() {
                this.updateServiceModal.modal = false;
                this.refreshService(this.selectedService);
                this.selectedService = {};
                console.log("Modal window closed: update");
            },

            /**
             * Open modal window for confirmation of an action
             * @param {Object} service service to delete
             */
            openConfirm(service) {
                this.deleteServiceConfirm.modal = true;
                this.selectedService = service;
                console.log("Modal window opened: Deleting confirmation");
            },

            /**
             * Close modal window after confirmation or cancel of delete. Delete the current service if confirmation, simply close the window if not
             * @param {Boolean} confirm to see if user confirmed or cancelled action
             * @param {String} modal Name of modal window 
             * @param {Object} currentService current service to delete or not 
             */
            async closeConfirmDelete(confirm, modal, currentService) {
                if (confirm === false) {
                    this[modal].modal = false;
                    console.log(`Modal window closed : ${modal}`);
                } else {
                    try {
                        await apiService.deleteService(currentService);
                        this.services.splice(this.services.findIndex((serv) => serv._id == currentService._id), 1);
                        this.$noty.success(this.$t("service-deleted"));
                        this[modal].modal = false;
                        this.updateCounters();
                    } catch (error) {
                        console.log(error);
                    }
                }
            },

            /**
             * Displays the list of services with a counter of up/down/ignored services
             */
            async getServices() {
                try {
                    this.services = await apiService.getServices();
                    console.debug(this.services);
                    this.updateCounters();
                } catch (error) {
                    console.error(error);
                }
            },
            
            /**
             * Allows to refresh manually a service
             * @param {Object} service current service to refresh
             */
            async refreshService(service) {
                try {
                    service = await apiService.getService(service);
                    this.services.splice(this.services.findIndex((serv) => serv._id == service._id), 1, service);
                    this.updateCounters();
                } catch (error) {
                    console.error(error);
                    this.$noty.error(this.$t("error-occured"));
                }
            },

            /**
             * Update the counters of services
             */
            updateCounters() {
                let up = this.services.filter(service => service.status === "up" && service.monitored == true).length;
                let down = this.services.filter(service => service.status === "down" && service.monitored == true).length;
                let ignored = this.services.filter(service => service.monitored == false).length;
                this.$emit("counter", [up, down, ignored]);
            },

        },

        /**
         * Displays the list of services with auto-refresh
         */
        async mounted () {
            try {
                await this.getServices();
                let refreshRate = JSON.parse(localStorage.getItem("user")).refreshRate;
                setInterval(async () => await this.getServices(), refreshRate * 1000);
            } catch (error) {
                console.error(error);
                this.$noty.error(this.$t("error-occured"));
            }
        },
    };
</script>

<style scoped>
.service-title {
    color: #71A0FF;
}

.service-information {
    color: #888888;
}
</style>

<i18n>
{
    "en": {
        "service-deleted": "Service deleted !",
        "modify-service": "Modify service",
        "modify": "Modify",
        "delete-service": "Delete a service",
        "delete-service-message": "Do you really wish to delete this service ?"
    },
    "fr": {
        "service-deleted": "Service supprimé !",
        "modify-service": "Modifier service",
        "modify": "Modifier",
        "delete-service": "Supprimer un service",
        "delete-service-message": "Souhaitez-vous vraiment supprimer définitivement ce service ?"
    }
}
</i18n>